# hello_world_arm.s

#  assemble with     "as -o hello_world_arm.o hello_world_arm.s"
#  link with         "ld -o hello_world_arm hello_world_arm.o"

# Run "./hello_world_arm"


# Syscalls
.equ SYSCALL_EXIT,	1
.equ SYSCALL_WRITE,	4

.equ STDOUT,		1


        .globl _start
_start:

	mov	r0,#0			@ set loop index to 0
loop:
	push	{r0}
	bl	print_hello

	pop	{r0}

	add	r0,r0,#1
	cmp	r0,#10
	bne	loop



        #================================
        # Exit
        #================================
exit:
	mov	r0,#5
        mov     r7,#SYSCALL_EXIT	@ put exit syscall number in r7
	swi	0x0			@ and exit


	#===============================
	# Print Hello
	#===============================

print_hello:
	push	{lr}
	mov	r0,#STDOUT		/* stdout */
	ldr	r1,=hello
	mov	r2,#13			@ length
	mov	r7,#SYSCALL_WRITE
	swi	0x0
	pop	{pc}


.data
hello:		.ascii "Hello World!\n"
